package launching;

import java.io.File;
import java.io.IOException;
import java.util.Map;

import org.apache.tools.ant.DefaultLogger;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectHelper;
import org.eclipse.ant.core.AntCorePlugin;
import org.eclipse.ant.core.AntRunner;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.papyrus.MARTE.MARTEPackage;
import org.eclipse.papyrus.MARTE.MARTE_AnalysisModel.GQAM.GQAMPackage;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.ProfileApplication;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.UMLPlugin.ExtensionProcessor;
import org.eclipse.uml2.uml.resource.UMLResource;
import org.eclipse.uml2.uml.resources.util.UMLResourcesUtil;

import launching.AntExecutor;

public class Launcher {

	// static String UMLMARTE_PROFILE_ID = "org.eclipse.papyrus.marte";
	// static String UMLMARTE_NS_URI = UMLRealTimePackage.eNS_URI;
	// //"http://www.eclipse.org/papyrus/umlrt"
	// static UMLRealTimePackage UMLRT_PKG = UMLRealTimePackage.eINSTANCE;
	static String MARTE_PATHMAP = "pathmap://Papyrus_PROFILES/MARTE.profile.uml";
	static ResourceSet resourceSet;

	public static void runBuild() throws CoreException {
		ExtensionProcessor.process(Launcher.class.getClassLoader());

		String dir = "resources/transformations/antlaunch/forward/";
		String completePath = dir + "build.xml";
		ResourceSet rset = new ResourceSetImpl();
		rset.getResourceFactoryRegistry().getExtensionToFactoryMap().put(UMLResource.FILE_EXTENSION,
				UMLResource.Factory.INSTANCE);
//		EPackage.Registry.INSTANCE.put(UMLPackage.eNS_URI, UMLPackage.eINSTANCE);
//		EPackage.Registry.INSTANCE.put(MARTEPackage.eNS_URI, MARTEPackage.eINSTANCE);
//		EPackage.Registry.INSTANCE.put(GQAMPackage.eNS_URI, GQAMPackage.eINSTANCE);
		Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put("uml", UMLResource.Factory.INSTANCE);

		File buildFile = new File(completePath);
		launching.AntExecutor.executeAntTask(buildFile.getAbsolutePath(), "targetModels");
	}

	/**
	 * Main method to test code
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		String dir = "resources/transformations/antlaunch/forward/";
		String completePath = dir + "build.xml";
		// Running default target of ant script
		// AntExecutor.executeAntTask(completePath);
		System.out.println("-----------------------------");
		// Running specified target of ant script
		// AntExecutor.executeAntTask(completePath, "loadModels");
		// AntExecutor.executeAntTask(completePath, "targetModels");
		try {
			runBuild();
		} catch (CoreException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
